/*
 *   __               .__       .__  ._____.           
 * _/  |_  _______  __|__| ____ |  | |__\_ |__   ______
 * \   __\/  _ \  \/  /  |/ ___\|  | |  || __ \ /  ___/
 *  |  | (  <_> >    <|  \  \___|  |_|  || \_\ \\___ \ 
 *  |__|  \____/__/\_ \__|\___  >____/__||___  /____  >
 *                   \/       \/             \/     \/ 
 *
 * Copyright (c) 2006-2011 Karsten Schmidt
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * http://creativecommons.org/licenses/LGPL/2.1/
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

package toxi.geom.mesh;

import toxi.geom.Vec3D;

/**
 *
 * @author tux
 */
public class Vertex extends Vec3D {

    /**
     *
     */
    public final Vec3D normal = new Vec3D();

    /**
     *
     */
    public final int id;

    /**
     *
     * @param v
     * @param id
     */
    public Vertex(Vec3D v, int id) {
        super(v);
        this.id = id;
    }

    final void addFaceNormal(Vec3D n) {
        normal.addSelf(n);
    }

    final void clearNormal() {
        normal.clear();
    }

    final void computeNormal() {
        normal.normalize();
    }

    /**
     *
     * @return
     */
    @Override
    public String toString() {
        return id + ": p: " + super.toString() + " n:" + normal.toString();
    }
}