/*
 *   __               .__       .__  ._____.           
 * _/  |_  _______  __|__| ____ |  | |__\_ |__   ______
 * \   __\/  _ \  \/  /  |/ ___\|  | |  || __ \ /  ___/
 *  |  | (  <_> >    <|  \  \___|  |_|  || \_\ \\___ \ 
 *  |__|  \____/__/\_ \__|\___  >____/__||___  /____  >
 *                   \/       \/             \/     \/ 
 *
 * Copyright (c) 2006-2011 Karsten Schmidt
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * http://creativecommons.org/licenses/LGPL/2.1/
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

package toxi.util.datatypes;

/**
 * This class encapsulates a single element within a {@link WeightedRandomSet}.
 * 
 * @param <T>
 */
public class WeightedRandomEntry<T> implements
        Comparable<WeightedRandomEntry<T>> {

    /**
     *
     */
    protected T item;

    /**
     *
     */
    protected int weight;

    /**
     *
     * @param item
     * @param weight
     */
    public WeightedRandomEntry(T item, int weight) {
        this.item = item;
        this.weight = weight;
    }

    /**
     *
     * @param e
     * @return
     */
    @Override
    public int compareTo(WeightedRandomEntry<T> e) {
        return (e.weight - weight);
    }

    /**
     *
     * @return
     */
    @Override
    public String toString() {
        return item.toString() + ": " + weight;
    }
}